<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class GpePessoah extends \Doctrine\ORM\EntityRepository {
    
        
    public function retornaHistoricoAtualPorPessoa($nrorg, $nrpessoa, $dtmescompetenc){
	$params = array('nrpessoa' => $nrpessoa, 'nrorg'=>$nrorg, 'dtmescompetenc' => $dtmescompetenc);
    $gpePessoah =  '\Teknisa\Model\Gestaopessoas\Entities\GpePessoah';

$sql = <<<SQL
SELECT s FROM $gpePessoah s
WHERE s.nrorg = :nrorg
    and s.nrpessoa = :nrpessoa    
    and s.dtmescompetenc = (
        SELECT MAX(sh.dtmescompetenc) FROM $gpePessoah sh
        WHERE sh.nrorg = s.nrorg
        and sh.nrpessoa = s.nrpessoa    
        and sh.dtmescompetenc <= :dtmescompetenc
        )
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return end($result);
    }
    
    public function retornaPessoaConselhoRegional($nrorg, $nrconselhoreg, $nrinscrconsreg, $dtmescompetenc){
        $gpe_pessoa = Repositories::GPE_PESSOA;
        $gpe_pessoah = Repositories::GPE_PESSOAH;
        
$sql = <<<SQL
SELECT ph.nrorg, 
       ph.nmpessoa, 
       ph.nrpessoa, 
       ph.nrpessoah, 
       ph.nrconselhoreg, 
       ph.nrinscrconsreg, 
       ph.dtexconsreg, 
       ph.sgufconsreg
  FROM $gpe_pessoa pm 
  JOIN $gpe_pessoah ph WITH ph.nrpessoa = pm.nrpessoa 
                     AND ph.nrorg = pm.nrorg 
                     AND ph.dtmescompetenc = ( SELECT MAX(h1.dtmescompetenc) 
                                                 FROM $gpe_pessoah h1 
                                                WHERE h1.nrpessoa = ph.nrpessoa 
                                                  AND h1.nrorg = ph.nrorg 
                                                  AND h1.dtmescompetenc <= :p_dtmescompetenc) 
 WHERE pm.nrorg = :p_nrorg 
   AND (ph.nrconselhoreg = :p_nrconselhoreg OR :p_nrconselhoreg IS NULL)    
   AND ph.nrinscrconsreg = :p_nrinscrconsreg
SQL;
        
        $params = array('p_nrorg'          => $nrorg, 
                        'p_nrconselhoreg'  => $nrconselhoreg, 
                        'p_nrinscrconsreg' => $nrinscrconsreg, 
                        'p_dtmescompetenc' => $dtmescompetenc);
        
        return $this->getEntityManager()->createQuery($sql)->execute($params);
        
    }   
    
    public function retornaPessoaNrinscrconsreg($nrorg, $nrinscrconsreg, $dtmescompetenc){
        $gpe_pessoah = Repositories::GPE_PESSOAH;
        
$sql = <<<SQL
SELECT peh.nrorg, 
       peh.nmpessoa, 
       peh.nrpessoa, 
       peh.nrpessoah,
       peh.nrinscrconsreg
                        from $gpe_pessoah peh
                    where peh.nrorg = :p_nrorg
                        and peh.nrinscrconsreg = :p_nrinscrconsreg
                        and peh.dtmescompetenc = (select max(pehs.dtmescompetenc)
                                                    from  $gpe_pessoah pehs
                                                  where pehs.nrorg = peh.nrorg
                                                    and pehs.nrinscrconsreg = :p_nrinscrconsreg
                                                    and pehs.dtmescompetenc <= :p_dtmescompetenc)
SQL;
        
        $params = array("p_nrorg" => $nrorg,
                        "p_nrinscrconsreg" => $nrinscrconsreg,
                        "p_dtmescompetenc" => $dtmescompetenc);
        
        return $this->getEntityManager()->createQuery($sql)->execute($params);
        
    }
    
    

}